/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.1-Beta3, Date: 14-Jan-2005.
 * Copyright (c) 2003-2006 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxStreamFile.h"
#include "rtxmlsrc/rtSaxCParser.h"
#include "fixml-components-base-4-4.h"

int main (int argc, char** argv)
{
   FIXML pdu;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       trace = TRUE, verbose = FALSE;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-i")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: reader [-v] [-i <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -i <filename>  read encoded msg from <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Init PDU data type variable */

   Init_FIXML (&ctxt, &pdu);

   /* Create input source object */

   stat = rtxStreamFileOpen (&ctxt, filename, OSRTSTRMF_INPUT);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }

   /* Decode */

   if (0 == stat)
      stat = XmlD_FIXML (&ctxt, &pdu);

   if (0 == stat) {
      if (trace) {
         printf ("Decode was successful\n");
         printf ("Decoded record:\n");
         Print_FIXML ("FIXML", &(pdu));
      }
   }
   else if (trace) {
      printf ("decode failed\n");
      rtxErrPrint (&ctxt);
   }

   MemFree_FIXML (&ctxt, &pdu);

   rtxStreamClose (&ctxt);
   rtxFreeContext (&ctxt);

   return stat;
}
