/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.2.A, Date: 23-Jun-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxStreamFile.h"
#include "test.h"
#include "rtxsrc/rtxMemLeakCheck.h"
#include "rtxsrc/rtxDiag.h"

int main (int argc, char** argv)
{
   c_meterSubscription pdu;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  jsonfname = "message.json";
   OSBOOL       trace = TRUE;
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-i")) jsonfname = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-notrace")) trace = FALSE;
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: reader [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -i <filename>  read encoded msg from <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Decode JSON */

   Init_c_meterSubscription (&ctxt, &pdu);

   stat = rtxStreamFileCreateReader (&ctxt, jsonfname);
   if (0 == stat) {
      stat = JsonDec_meterSubscription (&ctxt, &pdu);
   }
   if (0 == stat) {
      if (trace) {
         printf ("Decode was successful\n");
         printf ("Decoded record:\n");
         Print_c_meterSubscription ("meterSubscription", &(pdu));
      }
   }
   else {
      printf ("Decode failed\n");
      rtxErrPrint (&ctxt);
   }
   rtxStreamClose (&ctxt);

   rtxFreeContext (&ctxt);

   return stat;
}
