package com.objsys.xbinder.sample.rss;

import gen.rss.*;

import org.xmlpull.v1.*;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;


/**
 * Provides service of obtaining an Rss_CC object given a URL.
 * The Rss_CC is the generated class that contains the RSS feed from the URL.
 */
public class RSSClient {

   public static Rss_CC getFeed(String url) {
	  
      //create an XmlPullParser on the file
      XmlPullParser reader = null;
      try {
         InputStream in = null;

         URL urlObj = new URL(url);
         in = urlObj.openStream();

         XmlPullParserFactory inputFactory = XmlPullParserFactory.newInstance();
         inputFactory.setNamespaceAware(true);
         reader = inputFactory.newPullParser();
         reader.setInput( new BufferedInputStream( in ), null );

         //create _CC object
         Rss_CC root = new Rss_CC();
         root.decodeDocument(reader);

         return root;
      }
      catch (Exception e ) { 
         System.out.println ( "Error at " + 
               reader.getLineNumber()+
               reader.getColumnNumber() );
         if ( e instanceof RuntimeException ) throw (RuntimeException) e;
         else throw new RuntimeException(e);
      }
   }
}